# List Streaming Locators

> Media API · Streaming Locators

```http
GET https://app.mk.io/api/v1/projects/{project_name}/media/streamingLocators
```

## Listing, Sorting and Filtering Streaming Locators

This endpoint returns the list of streaming locators in the specified project.

### Sorting

The results from this endpoint can be ordered using the `$orderby` query parameter. Specify a list of field names, separated by commas
where each one can optionally specify `asc` or `desc`.

Sorting is valid on the following fields: `created`, `createdBy`, `id`, `name`, `properties/created`, `properties/endTime`, `properties/startTime`, `updated`, `updatedBy`

### Filtering

The `$filter` query parameter allows for streaming locators to be filtered on the basis of fields in the schema using OData query syntax.
See [this document](https://learn.microsoft.com/en-us/odata/concepts/queryoptions-overview#filter) for more details on the syntax used.

Filters are valid on the following fields: `created`, `createdBy`, `createdByEmail`, `createdByName`, `id`, `name`, `properties/assetName`, `properties/created`, `properties/endTime`, `properties/startTime`, `updated`, `updatedBy`, `updatedByEmail`, `updatedByName`

### Examples:

`?$top=10` - Returns only the first 10 streaming locators from the list.

`?$orderby=name desc` - Sorts streaming locators by name in descending order.

`?$filter=name eq 'descriptive name'` - Returns streaming locators that match the provided name.

`?$orderby=created desc` - Sorts streaming locators by creation date in descending order.

`?$filter=created ge 2021-01-01T00:00:00Z` - Returns streaming locators created after January 1, 2021.

RBAC Capability Required: `ams.streaminglocator.get`

## Authentication

- `Authorization` header — Bearer authentication of the form `Bearer <token>`.

## Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `project_name` | string | Yes | — |

## Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `$orderby` | string | No | Specifies the key by which the result collection should be ordered. |
| `$filter` | string | No | Restricts the set of items returned. |
| `$top` | string | No | Specifies a non-negative integer `n` that limits the number of items returned from a collection. The service returns the number of available items up to but not greater than the specified value `n`. |
| `$skiptoken` | string | No | Specifies a start offset to support paginated results. Use `@odata.nextLink` in the result object to enumerate the collection - it will be present only if there's more than one page of entities. |

## Example request

```bash
curl -X GET "https://app.mk.io/api/v1/projects/{project_name}/media/streamingLocators" \
  -H "Authorization: Bearer <token>"
```

## Responses

### 200 — A list of storage accounts

- `@odata.nextLink` · string · Optional — @odata.nextLink URL if the page length and number of items match.
- `supplemental` · object · **Required** — Supplemental info
  - `count` · integer · **Required** — Number of items returned
  - `kind` · string · **Required** — Type of items in the list
  - `operation` · string · **Required** — Operation type. Should always say 'list'
  - `pagination` · object · **Required** — Pagination info
    - `end` · integer · **Required** — Position of the last item in the list
    - `records` · integer · **Required** — Total number of items returned in the list
    - `start` · integer · **Required** — Position of the first item in the list
    - `total` · integer · **Required** — Total number of items in the project
  - `subscription` · object · Optional — Project info
    - `id` · string · **Required** — Project ID
    - `name` · string · **Required** — Project name
- `value` · list of objects · **Required** — The list of streaming locators
  - Array items (object):
    - `id` · string · Optional — Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
    - `name` · string · Optional · _1-260 characters_ · _pattern: ^[^\^\'<>%&:\\?/*+]+$_ — The name of the resource
    - `properties` · object · **Required** — Properties for streaming locator
      - `alternativeMediaId` · string · Optional — The alternative media id of the asset used by this streaming locator
      - `assetName` · string · **Required** — The name of the asset used by this streaming locator
      - `contentId` · string · Optional · _1-260 characters_ — Optional content ID. Only valid when an external key server is used.
      - `contentKeys` · list of objects · Optional — The content keys used by this streaming locator
        - Array items (object):
          - `id` · string · **Required** — The id of the content key
          - `labelReferenceInStreamingPolicy` · string · Optional — The label reference in the streaming policy
          - `policyName` · string · Optional — The name of the policy
          - `tracks` · list of objects · Optional — Not currently supported. The tracks which use this content key
            - Array items (object):
              - `trackSelections` · list of objects · **Required** — The track selections
                - Array items (object):
                  - `operation` · object · **Required** — The track property comparison operation
                    - `Equal` · string · **Required** — The track property comparison operation
                    - `Unknown` · string · **Required** — The track property comparison operation
                  - `property` · string · **Required** — The track property to compare against
                  - `value` · string · **Required** — The track property value.
          - `type` · enum · Optional — The streaming locator content key type
            - Allowed values: `CommonEncryptionCenc`, `CommonEncryptionCbcs`, `EnvelopeEncryption`
          - `value` · string · Optional — The value of the content key
      - `defaultContentKeyPolicyName` · string · Optional · _<=260 characters_ — The default content key policy name used by this streaming locator.
      - `defaultManifestFilename` · string · Optional · _1-260 characters_ · _pattern: ^[A-Za-z0-9 _.,()-]+$_ — Manifest filename used with streaming endpoints that have urlStyle set to 'Aquila' or 'Unified'. For example: manifest.ism (for MP4 assets), manifest.mpd (for TS assets), index.qfm (for live events)
      - `endTime` · string · Optional · _format: date-time_ — The end time of the streaming locator
      - `filters` · list of strings · Optional — A list of asset or account filters to apply to the streaming locator.
        - Array items (string):
      - `provisioningState` · enum · Optional — The provisioning state of the streaming locator. Set by the system. One of InProgress, Succeeded, Failed.
        - Allowed values: `InProgress`, `Succeeded`, `Failed`
      - `resourceState` · enum · Optional — The runtime state of the streaming locator. Set by the system.
        - Allowed values: `Creating`, `Updating`, `Deleting`, `Created`, `Deleted`, `Error`
      - `startTime` · string · Optional · _format: date-time_ — The start time of the streaming locator
      - `streamingLocatorId` · string · Optional · _1-260 characters_ · _pattern: ^[^\/]+$_ — The streaming locator id
      - `streamingPolicyName` · string · **Required** · _<=260 characters_ — The name of the streaming policy used by this streaming locator. You may specify a custom policy by name, or used one of the predefined policies. To get the list of valid policy options use the `GET /api/v1/projects/{project_name}/media/streamingPolicies` endpoint.
      - `suppressed` · boolean · Optional · _Defaults to false_ — Optional configuration for output suppression. A suppressed locator will return a 404 HTTP response to requests, in the same way it would if the `startTime` had not yet been reached. The 404 code can be overridden with a different status code by setting `preAvailabilityStatusCode` in a custom catalog in a Streaming Policy.
    - `systemData` · object · Optional — Metadata pertaining to creation and last modification of the resource.
      - `createdAt` · string · **Required** · _format: date-time_ — The timestamp of resource creation (UTC).
      - `createdBy` · string · **Required** — The identity that created the resource.
      - `createdByType` · enum · **Required** — The type of identity that created the resource.
        - Allowed values: `User`, `Application`, `ManagedIdentity`, `Key`
      - `internalId` · string · **Required** · _format: uuid_ — The internal ID of the resource.
      - `lastModifiedAt` · string · **Required** · _format: date-time_ — The timestamp of resource last modification (UTC).
      - `lastModifiedBy` · string · **Required** — The identity that last modified the resource.
      - `lastModifiedByType` · enum · **Required** — The type of identity that last modified the resource.
        - Allowed values: `User`, `Application`, `ManagedIdentity`, `Key`
    - `type` · string · Optional — The type of the resource. E.g. "Microsoft.Media/mediaservices/assets"

Example:

```json
{
  "@odata.nextLink": "string",
  "supplemental": {
    "count": 0,
    "kind": "string",
    "operation": "string",
    "pagination": {
      "end": 0,
      "records": 0,
      "start": 0,
      "total": 0
    },
    "subscription": {
      "id": "string",
      "name": "string"
    }
  },
  "value": [
    {
      "id": "string",
      "name": "name",
      "properties": {
        "alternativeMediaId": "string",
        "assetName": "string",
        "contentId": "string",
        "contentKeys": [
          {
            "id": "string",
            "labelReferenceInStreamingPolicy": "string",
            "policyName": "string",
            "tracks": [
              {
                "trackSelections": [
                  {
                    "operation": {
                      "Equal": "string",
                      "Unknown": "string"
                    },
                    "property": "string",
                    "value": "string"
                  }
                ]
              }
            ],
            "type": "CommonEncryptionCenc",
            "value": "string"
          }
        ],
        "defaultContentKeyPolicyName": "string",
        "defaultManifestFilename": "string",
        "endTime": "2024-01-01T00:00:00Z",
        "filters": [
          "string"
        ],
        "provisioningState": "InProgress",
        "resourceState": "Creating",
        "startTime": "2024-01-01T00:00:00Z",
        "streamingLocatorId": "00000000-0000-0000-0000-000000000000",
        "streamingPolicyName": "string",
        "suppressed": false
      },
      "systemData": {
        "createdAt": "2024-01-01T00:00:00Z",
        "createdBy": "string",
        "createdByType": "User",
        "internalId": "00000000-0000-0000-0000-000000000000",
        "lastModifiedAt": "2024-01-01T00:00:00Z",
        "lastModifiedBy": "string",
        "lastModifiedByType": "User"
      },
      "type": "string"
    }
  ]
}
```

### 400 — Bad Request

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 401 — Unauthorized

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 403 — Forbidden

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 404 — Not Found

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 429 — Too Many Requests

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 500 — Internal Server Error

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

---

Source spec: `media-api` · operationId: `[get]_/api/v1/projects/{project_name}/media/streamingLocators`
